import java.util.*;

public class StringPriorityQueue
{
	public static void main (String[ ] args)
	{
		new StringPriorityQueue().run();
	 } // method main
	
	public void run()
	{
		Queue<String> pq = new PriorityQueue<String> ();
		Queue<String> pq_byLenght = new PriorityQueue<String> (new ByLength());        

		pq.add ("yes");
        pq.add ("no");
        pq.add ("maybe");
        pq.add ("wow");
        System.out.println("Alphabetical order:"); 
		 while (!pq.isEmpty())
			System.out.println (pq.remove());
        
        pq_byLenght.add ("yes");
        pq_byLenght.add ("no");
        pq_byLenght.add ("maybe");
        pq_byLenght.add ("wow");
        System.out.println("\nOrder by string length:");
		 while (!pq_byLenght.isEmpty())
			System.out.println (pq_byLenght.remove());
	} // method run
} // class StringPriorityQueue



class ByLength implements Comparator<String> 
{
/** 
 *  Compares two specified String objects 
 *  lexicographically if they have the same length, and 
 *  otherwise returns the difference in their lengths.
 *
 *  @param s1  one of the specified String objects.
 *  @param s2  the other specified String object.
 *
 *  @return s1.compareTo (s2) if s1 and s2 have the 
 *                same length; otherwise, return
 *                 s1.length()  s2.length(). 
 *
 */	
	public int compare (String s1, String s2) 
	{
		int len1 = s1.length(),
 		    len2 = s2.length();
		if (len1 == len2) return s1.compareTo (s2);
        	
		return len1-len2;
    	} // method compare

} // class ByLength
