import java.util.Comparator;

/**
 * A trivial implementation of the simple queue interface, built as
 * a wrapper around the ALBinaryHeap  class
 */
public class HeapPriorityQueue<T extends Comparable<? super T>>
   	implements MyQueue<T> {

	private ListBinaryHeap<T> data;
    
    /**
     *  Constructs the binary heap given a comparator
     */
    public HeapPriorityQueue() {data = new ListBinaryHeap<T>();} 
    
    /**
     *  Constructs the binary heap given a comparator
     */
    public HeapPriorityQueue(Comparator<T> comparator)
    {
    	data = new ListBinaryHeap<T>(comparator);
    }
    
    public boolean add(T item) {data.insert(item); return true;}
    
    public T remove() {
	return data.deleteMin(); 
    }
    
    public T peek() {
	if (isEmpty()) return null;
	else return data.findMin(); 
    }
    
    public int size() {return data.size();}
    
    public boolean isEmpty() {return data.isEmpty();}

}